// Nazev:   Genrator hlidacich obvodu
// Soubor:  lex.h
// Popis:   implementace lexikalniho analyzatoru
// Datum:   2007-05-10
// Autor:   strakam@fit.vutbr.cz, Martin Straka, DIT 2007
//========================================================================

#ifndef lexH
#define lexH
#include <fstream>
#include <string>
#include <list>
#include <iostream>
//#include <vector>

using namespace std;
// -----------------------------------------------------------------------------
//extern int
 //        lexColumn,      // i-ty token na radku
//         lexLine,        // cislo radku
//                  // obsahuje nactenou int hodnotu
///extern string
//         lexStr,lexInt;        // obsahuje nacteny text (id,str)

// ---[ typ symbol ]---------------------------------------------------------
enum  TSymbol{
   eofSym, intkonstSym, negaceSym,  levazavoraSym,
   pravazavoraSym, strednikSym, carkaSym, dvojteckaSym, idSym,
   vetsiSym, mensiSym, vetsirovnoSym, mensirovnoSym, rovnostSym,
   ruznostSym, priradSym, stavySym, podminkySym, andSym, orSym
};

//------------------------------------------------------------------------------
// tabulka nazvu symbolu - pri zmene TSymbol nutno aktualizovat
extern const string symbolCaptions[20];

extern int
         section,
         lexColumn,vect,vector,      // i-ty token na radku
         lexLine;        // cislo radku
 extern string        lexInt;         // obsahuje nactenou int hodnotu
extern string
         lexStr;        // obsahuje nacteny text (id,str)
extern int section;
// -----------------------------------------------------------------------------
bool lexInit(string inputFileName);
void lexFree(string inputFileName);
//string getnextchar();
TSymbol lex();

void lexDebug(string inputFileName);          // chybove hlaseni
void lexTotalError(string msg);
void synTotalError(string msg);
#endif

